#!/bin/bash
#
# wait for files which need to be renamed
# then call T85exifren.sh (given as first parameters, then all parameters to give to it)
#
# utilizes inotifywait

[ -z "$T85exifsleep" ] && T85exifsleep=60

exifren=$1
shift

# if Parameter 1 is set, it is the T85exifsrcdir
[ "$1" ] && T85exifsrcdir="$1"
[ -z "$T85exifsrcdir" ] && T85exifsrcdir="$T85nasdir"

cd "$T85exifsrcdir"

# singleton pattern
LOCKFILE="$0"
( if flock -n 99
then
  echo running task waiting for pics
# singleton doing things here
  echo $(date +"%Y%m%d_%H%M%S") call T85exifren
  $exifren "$@"
  while true
  do
    echo $(date +"%Y%m%d_%H%M%S") wait for file in $(pwd)
    while [ -e T85exifwait.pause ]
    do
      [ "$T85DBG" ] && echo "dbg pause"
      sleep 1
    done
    inotifywait -e create,close_write,moved_to . 
    status=$?
    if [[ "$status" == "0" ]]; then
      unset -v latest
      while [[ "$latest" == "" ]]
      do
        for file in "$1"/*; do
          [[ $file -nt $latest ]] && latest=$file
        done
#        filetime=$(date -r "$file" +%s)
        filetime=$(stat -c %Z ".")
        now=$(date +%s)
        timediff=$(($now-$filetime))
        if (( $timediff < $T85exifsleep )); then
          unset -v latest
          echo $(date +"%Y%m%d_%H%M%S") sleep $(($T85exifsleep-$timediff))
          sleep $(($T85exifsleep-$timediff))
		else
		  echo $(date +"%Y%m%d_%H%M%S") file $latest is $timediff seconds old, that is enough
        fi
      done
      echo $(date +"%Y%m%d_%H%M%S") call T85exifren
      $exifren "$@"
    else
      echo $(date +"%Y%m%d_%H%M%S") status $status from inotifywait
    fi
  done
# singleton doing things end
  exit 0
else
  echo $(date +"%Y%m%d_%H%M%S") already running, do nothing
fi ) 99<$LOCKFILE


